
#include <stdio.h>
#include "Matrix.h"

/*	n°  Ǻġ  ϴ Լ	*/
int GetFibo(int n);

/*	2X2 FiboMat n ϴ Լ	*/
Matrix2X2 FiboMatPower(int n);

int main(void)
{
	int n = 13;	//	13°  ǹ

	printf("%d°  Ǻġ  %d̴.\n", n, GetFibo(n));
	return 0;
}

/*	n°  Ǻġ  ϴ Լ	*/
int GetFibo(int n)
{
	const int F0 = 0;
	const int F1 = 1;

	Matrix2X2 C;
	Matrix2X1 B;

	if (n == 0)			return F0;
	else if (n == 1)	return F1;

	else
	{
		C = FiboMatPower( n - 1 );	//	FiboMat (n - 1) 
		B = MakeMatrix2X1(F1, F0);	//	 캯  

		/*	MatrixMultiply2X1Լ 2X2İ 2X1  ϴ Լ	*/
		Matrix2X1 Ret = MatrixMultiply2X1(C, B);	//	 캯 

		return Ret.a11;			//	1 1 Ұ n°  Ǻġ ̴.
	}
}

/*	2X2 FiboMat n ϴ Լ	*/
Matrix2X2 FiboMatPower(int n)
{
	Matrix2X2 mat = MakeMatrix2X2(1, 1, 1, 0);	//	FiboMat 
	Matrix2X2 partitionResult;
	Matrix2X2 half;

	/*	 Լ Ż 	*/
	if (n == 1)	
		return mat;
	
	/*	FiboMat  (n / 2) ϸ, FiboMat n   ִ.	*/
	else
	{
		half = FiboMatPower( n / 2 );

		// n ¦̸, FiboMat  (n / 2) FiboMat  (n / 2) ϸ ȴ.
		if (n % 2 == 0)
		{
			partitionResult = MatrixMultiply2X2(half, half);
		}
		/*
			n Ȧ̸, FiboMat  (n / 2) FiboMat  (n / 2)  , 
			 mat ϸ ȴ.
		*/
		else
		{
			partitionResult = MatrixMultiply2X2(half, half);
			partitionResult = MatrixMultiply2X2(partitionResult, mat);
		}
	}
	return partitionResult;
}

